<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RoomCategory ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RoomCategory extends AbstractStructArrayBase
{
    /**
     * The RoomCategory
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RoomCategory[]
     */
    public $RoomCategory;
    /**
     * Constructor method for ArrayOfJP_RoomCategory
     * @uses ArrayOfJP_RoomCategory::setRoomCategory()
     * @param \StructType\JP_RoomCategory[] $roomCategory
     */
    public function __construct(array $roomCategory = array())
    {
        $this
            ->setRoomCategory($roomCategory);
    }
    /**
     * Get RoomCategory value
     * @return \StructType\JP_RoomCategory[]|null
     */
    public function getRoomCategory()
    {
        return $this->RoomCategory;
    }
    /**
     * Set RoomCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RoomCategory[] $roomCategory
     * @return \ArrayType\ArrayOfJP_RoomCategory
     */
    public function setRoomCategory(array $roomCategory = array())
    {
        foreach ($roomCategory as $arrayOfJP_RoomCategoryRoomCategoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RoomCategoryRoomCategoryItem instanceof \StructType\JP_RoomCategory) {
                throw new \InvalidArgumentException(sprintf('The RoomCategory property can only contain items of \StructType\JP_RoomCategory, "%s" given', is_object($arrayOfJP_RoomCategoryRoomCategoryItem) ? get_class($arrayOfJP_RoomCategoryRoomCategoryItem) : gettype($arrayOfJP_RoomCategoryRoomCategoryItem)), __LINE__);
            }
        }
        $this->RoomCategory = $roomCategory;
        return $this;
    }
    /**
     * Add item to RoomCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RoomCategory $item
     * @return \ArrayType\ArrayOfJP_RoomCategory
     */
    public function addToRoomCategory(\StructType\JP_RoomCategory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RoomCategory) {
            throw new \InvalidArgumentException(sprintf('The RoomCategory property can only contain items of \StructType\JP_RoomCategory, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RoomCategory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RoomCategory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RoomCategory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RoomCategory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RoomCategory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RoomCategory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoomCategory
     */
    public function getAttributeName()
    {
        return 'RoomCategory';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_RoomCategory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
